package com.foo.jpaweb.model

import org.junit.Test
import org.junit.Before
import org.junit.After
import org.junit.Assert._

import javax.persistence._

class TestJPAWeb {
  var emf : EntityManagerFactory = _

  @Before
  def initEMF () = {
    emf = Persistence.createEntityManagerFactory("jpaweb")
  }

  @After
  def closeEMF () = {
    emf.close()
  }

  @Test
  def save_stuff () = {
    var em = emf.createEntityManager()

    val tx = em.getTransaction()

    tx.begin()

    val author = new Author
    author.name = "Chuck"

    em.persist(author)
    
    val book = new Book
    book.title = "Huh?"
    book.published = new java.util.Date
    book.author = author
    
    em.persist(book)

    tx.commit()

    em.close()

    // Re-open and query
    em = emf.createEntityManager()

    val retrieved = em.createNamedQuery("findAllBooks").getResultList().asInstanceOf[java.util.List[Book]]

    assertEquals(1, retrieved.size())

    println("Found " + retrieved.get(0).title)
  }
}
